
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Javascript中的构造函数与原型 / 憋错料</title>

    <meta name="description" content="Javascript中的构造函数与原型 构造函数 构造函数,是一种特殊的方法.主要用来创建对象时初始化对象,即为对象成员变量赋初始值,总与new运算符一起使用在创建对象的语句中.特别的一个类可以有多个构造函数,可根据其参数个数的不同或参数类型的不同来区分它们即构造函数的重载. 示例: &lt;span style=&quot;font-size:18px;&quot;&gt;function Box(name,age) { this.name=name; this.age=age; this.run=function(){ retur ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Javascript中的构造函数与原型</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<h1>构造函数</h1>
<p>构造函数，是一种特殊的方法。主要用来创建对象时初始化对象，即为对象成员变量赋初始&#20540;，总与new运算符一起使用在创建对象的语句中。特别的一个类可以有多个构造函数，可根据其参数个数的不同或参数类型的不同来区分它们即构造函数的重载。</p>
<p>示例：</p>
<pre>&lt;span style=&quot;font-size:18px;&quot;&gt;function Box(name,age)
{
	this.name=name;
	this.age=age;
	this.run=function(){
		return this.name+this.age+&#039;运行中。。。&#039;;
	};
}

var box1=new Box(&#039;Lee&#039;,100);
var box2=new Box(&#039;Jack&#039;,200);

alert(box1.run());
alert(box1 instanceof Box);
&lt;/span&gt;</pre>
<p>下面我们来用途看一下构造函数的声明函数。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjYxOTI2NTU4MTk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YldGelkyWT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<h1>原型</h1>
<p>我们创建的每个函数都有一个prototype(原型)属性，这个属性是一个对象，它的用途是包含可以由特定类型的所有实例共享的属性和方法。</p>
<p>使用原型的好处可以让所有对象实例共享它所包含的属性和方法。</p>
<p>示例：</p>
<pre>&lt;span style=&quot;font-size:18px;&quot;&gt;function Box(){}
		Box.prototype.name=&#039;Lee&#039;;
		Box.prototype.age=100;
		Box.prototype.run=function()
		{
			return this.name+this.age+&#039;运行中。。。&#039;
		};
//下面比较一下原型内的方法地址是否一致：
var box1=new Box();
var box2=new Box();
alert(box1.run==box2.run);	 //返回的结果为true,说明它们的引用地址是一样的。
&lt;/span&gt;</pre>
<p>用图来看一下原型的声明方式</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNTA0MjYxOTMwNDQyNDQ/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2YldGelkyWT0vZm9udC81YTZMNUwyVC9mb250c2l6ZS80MDAvZmlsbC9JMEpCUWtGQ01BPT0vZGlzc29sdmUvNzAvZ3Jhdml0eS9Tb3V0aEVhc3Q=.jpg"></p>
<p>由图中可以知道，构造函数是在内存中有创建了一个实例，增加了内存占用。而原型模式则是共用了属性和方法，则可以减轻内存的负担。</p>
<p>当然，原型模式创建对象也有自己的缺点，原型中所有属性是被很多实例共享的，共享对于函数非常合适，对于包含基本&#20540;得属性也还可以。 但是有的每次实例化的数据需要保留自己的特性，不能共享。这就造成了矛盾。</p>
<h1>构造函数&#043;原型模式</h1>
<p>为了解决这个问题，可以组合构造函数&#043;原型模式。</p>
<pre>&lt;span style=&quot;font-size:18px;&quot;&gt;function Box(name,age)		//不共享的使用构造函数
{
	this.name=name;
	this.age=age;
	this.family=[&#039;父亲&#039;,&#039;母亲&#039;,&#039;妹妹&#039;];
};

Box.prototype={				//共享的使用原型
	constructor:Box,
	run:function(){
		return this.name+this.age+this.family;
	}
};
&lt;/span&gt;</pre>
<p>通过对不共享的属性使用构造函数，而对于共享的方法，则用原型，就很好的解决了传参和引用共享的问题。</p>
<h1>总结：</h1>
<p>JavaScript中的面向对象和.net中的面向对象是差不多的，只是表现形式不同了而已。对比起来还是差不多的。当然，现在还是初次学习，以后还要更不断的学习，来加深认识。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 09:06:33 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Javascript中的构造函数与原型的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n4Amzd4.html" rel="bookmark">javascript中的构造函数和原型及原型链</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				纯属个人理解,有错误的地方希望大牛指出,以免误人子弟 1.构造函数: 构造函数的作用 : 初始化由new创建出来的对象    new 的作用: 创建对象(空对象) new 后面跟的是函数调用,使用new来调用函数,跟普通的直接调用函数主要的不同: 就是 this 的指向不同了 , 再就是 会自动的返回新创建的对象 什么是原型?        原型的作用:就是为了实现继承!  一个对象的原型就是它的构造函数的prototype属性的值. 在讨论原型的时候,是指的 对象和原型对关系 prototyp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kpKBL3.html" rel="bookmark">Javascript中的对象和原型&lpar;3&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Javascript中的对象和原型(二)中我们提到,用构造函数创建的对象里面,每个对象之间都是独立的,这样就会降低系统资源的利用率,解决这样问题,我们就要用到下面提到的原型对象. 一 原型对象 原型对象实际上就是构造函数的一个实例对象,和普通的实例对象没有本质上的区别.可以包含特定类型的所有实例的共享属性或者方法.这样,如果我们需要修改所有实例中的属性或者方法,就只需要修改一处,就能够影响到所有实例了.因为原型中的属性和方法是共享的.我们可以看下两个图示:       构造函数方式 原型模式方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3qNbx54.html" rel="bookmark">JavaScript中的构造函数和工厂函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript中的工厂函数 1 function crateHero (name,blood,weapoon) { 2 var o = new Object(); 3 o.name = name; 4 o.blood = blood; 5 o.weapoon = weapoon; 6 o.attch = function () { 7 console.log(this.name+&quot;用&quot;+this.weapoon+&quot;进行了攻击&quot;); 8 } 9 return o			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38LdKZ3.html" rel="bookmark">JavaScript中的继承与原型链</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先看一个例子 function User(){} var u1 = new User(); console.log(u1.prototype);// undefined 使用对象实例无法访问到prototype console.log(User.prototype);//{},使用构造函数名访问prototype console.log(u1.__proto__);//{},使用对象实例访问prototype的指针 这个是 __proto__ 和prototype最基本的区别:说明构造的对象无p			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kZR2jM.html" rel="bookmark">JavaScript中的继承（原型链）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.原型链 ECMAScript中将原型链作为实现继承的主要方法,基本思想是利用原型让一个引用类型继承另一个引用类型的属性和方法. 实例1: function SupType() { this.property = true; } SupType.prototype.getSupvalue = function() { return this.property; }; function SubType() { this.subproperty = false; } //原型对象等于一个类型的实例			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/38pNjy3.html" rel="bookmark">Javascript中的对象和原型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一 原型对象 原型对象实际上就是构造函数的一个实例对象,和普通的实例对象没有本质上的区别.可以包含特定类型的所有实例的共享属性或者方法.这样,如果我们需要修改所有实例中的属性或者方法,就只需要修改一处,就能够影响到所有实例了.因为原型中的属性和方法是共享的.我们可以看下两个图示:       构造函数方式 原型模式方式 从上面的图示中我们就不难看出,为何下面的代码中&quot;user1.show == user2.show;&quot;返回的是ture,因为show方法是所有由User构造函数创建的对象			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41VYpoM.html" rel="bookmark">Javascript中获取对象的原型对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在Javascript中,如果我们有一个对象但是又不知道它的构造函数时,如何获取它的原型对象呢? 在Chrome中或是FireFox浏览器中,我们可以直接使用对象的__proto__属性获取它的原型对象. &lt;!-- lang: js --&gt; function F(){}; var foo = new F(); alert(foo.__proto__ == F.prototype); 但是,__proto__属性在IE浏览器中一直到IE11才被支持. 那么在不支持__proto__属性的浏览器中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n3ZAoD0.html" rel="bookmark">JavaScript中的构造函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				function Accom(){};    //创建一个构造函数 //创建两个对象 var house=new Accom(); var apartment=new Accom(); 通过构造函数创建的对象有一个属性constructor,这个属性指向创建该对象时所用的Javascript构造函数. house.constructor===Accom;  或者   house instanceof Accom;     //true JavaScript中的每个构造函数都有一个prototyp			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLDv5dM.html" rel="bookmark">JavaScript中以构造函数的方式调用函数</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://www.cnblogs.com/Saints/p/6012188.html 构造器函数(Constructor functions)的定义和任何其它函数一样,我们可以使用函数声明.函数表达式或者函数构造器(见以前的随笔)等方式来构造函数对象.函数构造器和其它函数的区别在与它们的调用方式不同. 要以构造函数的方式调用函数,只需要在调用时在函数名称前加new 关键字,比如:function whatsMyContext(){ return this; }; 调用:new what			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/949G1g0.html" rel="bookmark" class="title">牛x的JavaScript编辑器你知道几个</a>
					<div>
						英文:Martin Heller  译文:葡萄城控件 学习过程中遇到什么问题或者想获取学习资源的话,欢迎加入学习交流群343599877,我们一起学前端! 对于JavaScript程序员来说,目前有很 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXYlez0.html" rel="bookmark" class="title">Borg Maze</a>
					<div>
						Description The Borg is an immensely powerful race of enhanced humanoids from the delta quadrant of  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lr7No4.html" rel="bookmark" class="title">ORA-XXXX，X你妹夫啊！</a>
					<div>
						第一.连接远程数据库错误:ORA-12514:listener does not currently know of service requested in connect descriptor 监 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R8gy94.html" rel="bookmark" class="title">htaccess不起作用的解决方法&comma;AllowOverride All打开后出现403错误时解决办法</a>
					<div>
						在php程序的目录下有一个htaccess文件,这个文件起着对url重写的作用,但是不巧的,在我的应用程序里不起作用,baidu了一下,发现是 AllowOverride All,  这个选项没有打开 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8JBB0.html" rel="bookmark" class="title">文本换行word-wrap、word-break与white-space</a>
					<div>
						本文同步至微信公众号:http://mp.weixin.qq.com/s?__biz=MzAxMzgwNDU3Mg==&amp;mid=401671055&amp;idx=1&amp;sn=b88c9 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVYZKw4.html" rel="bookmark" class="title">JavaSE8基础 HashMap isEmpty clear 判断该映射空不空与删除所有键值对</a>
					<div>
						os :windows7 x64    jdk:jdk-8u131-windows-x64    ide:Eclipse Oxygen Release (4.7.0) code: package ji ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8WYj3.html" rel="bookmark" class="title">软件工程结组项目总结</a>
					<div>
						在小组中,我主要负责需求分析.需求模型的设计和文档编写的工作.在环境图的设计中,我使用了网站processon的在线工具,根据书中的例子模仿画.最后在课上的讲解时,老师说我所画的不是环境图而是架构图. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4p57bVM.html" rel="bookmark" class="title">ArrayList LinkedList Vector</a>
					<div>
						ArrayList是基于数组实现的,没有容量的限制. 在删除元素的时候,并不会减少数组的容量大小,可以调用ArrayList的trimeToSize()来缩小数组的容量. ArrayList,Link ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MDvX7e3.html" rel="bookmark" class="title">你是喜欢一个人本身，还是</a>
					<div>
						我妈常常喜欢念叨:人家又不喜欢你,你干嘛还要去喜欢人家.以前我一直想不出什么话反驳,只好简单粗暴地回应:一边去,你一老娘儿们你懂什么你. 我见过很多人,换男女朋友比换内裤还勤快的那种自不必说,还有像我 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j11mgM.html" rel="bookmark" class="title">1、身份验证</a>
					<div>
						&lt;head&gt; &lt;meta http-equiv=&quot;Content-Type&quot; content=&quot;text/html; charset=utf-8&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aYmWP0.html" rel="bookmark" class="title">手动添加路由表</a>
					<div>
						route -p add 192.168.9.0 mask 255.255.255.0 192.168.10.83 要添加默认网关地址为192.168.12.1 的默认路由,请键入: route ad ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49LQjg3.html" rel="bookmark" class="title">修改Linux内核参数提高Nginx服务器并发性能</a>
					<div>
						当linux下Nginx达到并发数很高,TCP TIME_WAIT套接字数量经常达到两.三万,这样服务器很容易被拖死.事实上,我们可以简单的通过修改Linux内核参数,可以减少Nginx服务器 的TI ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3qRx694.html" rel="bookmark" class="title">优质代码</a>
					<div>
						&lt;pre name=&quot;code&quot; class=&quot;cpp&quot;&gt;/******************************************** ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWXY13.html" rel="bookmark" class="title">iOS 8：AFNetworking2&period;0源码解析 1</a>
					<div>
						源地址:http://blog.cnbang.net/tech/2320/ 最近看AFNetworking2的源码,学习这个知名网络框架的实现,顺便梳理写下文章.AFNetworking2的大体架构和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoLggy0.html" rel="bookmark" class="title">根据关键字查询存储或表</a>
					<div>
						--根据关键字查询SP select distinct a.name from sysobjects a,syscomments b where a.id=b.id and a.xtype='P' a ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lNWwN4.html" rel="bookmark" class="title">Pig用户自定义函数（UDF）转</a>
					<div>
						原文地址:http://blog.csdn.net/zythy/article/details/18326693 我们以气温统计和词频统计为例,讲解以下三种用户自定义函数. 用户自定义函数 什么时候需 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0jLDE94.html" rel="bookmark" class="title">C&num;中使用ADOMD&period;NET查询多维数据集</a>
					<div>
						ADOMD.NET 是用于与 Microsoft SQL Server Analysis Services 进行通信的 Microsoft .NET Framework 数据访问接口. ADOMD.N ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXZWDG3.html" rel="bookmark" class="title">动态修改样式和层叠样式表</a>
					<div>
						转自:http://www.cnblogs.com/micromouse/archive/2010/04/26/1721618.html W3C DOM2样式规则 ================== ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDZozM.html" rel="bookmark" class="title">解决Ubuntu下QtCreator中不能输入中文的问题</a>
					<div>
						解决方法: 1.安装fcitx-frontend-qt5 sudo apt-get install fcitx-frontend-qt5 2.复制libfcitxplatforminputcontex ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoX5rD0.html" rel="bookmark" class="title">uhttpd配置文件分析</a>
					<div>
						文件位于 /etc/config/uhttpd. [email protected]:/etc/config# cat uhttpd config uhttpd 'main'        list  ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
